'
' PBFILE include file - Public Domain by Borje Hagsten, January 2002.
' Totally self-containing via container window.
'
' LOG:
' Jan 14, 2003: Changed handles to DWORD and made corrections
'               to %WM_GETDLGCODE in PBFileProc
'               It now uses GetWindowLong(hWnd, %GWL_HINSTANCE)
'               to get proper instance handle at creation.
'
%DCM_SETFILESEL3DFACE = %WM_USER + 6000 ' wParam sets custom sel color, lParam decides redraw
%DCM_SETFILES         = %WM_USER + 6004 ' is passed on to PBFilesToList, lParam is pointer to path
'--------------------------------------------------------------------
TYPE PBFILECTLDATA
  oldProc    AS DWORD
  sel3Dface  AS LONG
  curPath    AS ASCIIZ * %MAX_PATH
  fileType   AS ASCIIZ * 20
END TYPE
'--------------------------------------------------------------------
DECLARE FUNCTION PBFileExist(BYVAL sfName AS STRING) AS LONG
DECLARE FUNCTION PBFileProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                            BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE SUB PBFilesToList(BYVAL hWnd AS DWORD, BYVAL AbsPath AS STRING, _
                          BYVAL fType AS STRING, BYVAL xAttr AS LONG)

'
' Create PB File control listbox
'
FUNCTION CreatePBFileLB ALIAS "CreatePBFileLB" _
                       (BYVAL hWnd AS DWORD, BYVAL CtrlId AS LONG, _
                        BYVAL vLeft AS LONG, BYVAL vTop AS LONG, _
                        BYVAL vWidth AS LONG, BYVAL vHeight AS LONG, _
                        BYVAL selStyle AS LONG, BYVAL DDTstyle AS LONG, _
                        BYVAL cDir AS STRING, fType AS STRING) AS LONG

  LOCAL hParent AS DWORD, hFileLst AS DWORD, lbFont AS DWORD, rc AS RECT
  LOCAL wc AS WNDCLASSEX, szClassName AS ASCIIZ * 20, fd AS PBFILECTLDATA PTR

  'REGISTER A CUSTOM CONTROL CLASS FOR CONTAINER WINDOW
  szClassName      = "PBFILEX"
  wc.cbSize        = LEN(wc)
  wc.lpfnWndProc   = CODEPTR(PBFileMainProc)
  wc.cbWndExtra    = 4
  wc.hInstance     = GetWindowLong(hWnd, %GWL_HINSTANCE)
  wc.lpszClassName = VARPTR(szClassName)

  RegisterClassEx wc

  IF DDTstyle THEN
     DIALOG UNITS hWnd, vLeft, vTop TO PIXELS vLeft, vTop
     DIALOG UNITS hWnd, vWidth, vHeight TO PIXELS vWidth, vHeight
  END IF

  'CREATE CONTAINER WINDOW, for redrawing operations in WM_DRAWITEM
  hParent = CreateWindowEx(0, "PBFILEX", BYVAL 0, %WS_VISIBLE OR %WS_CHILD OR %WS_TABSTOP, _
                           vLeft, vTop, vWidth, vHeight, _
                           hwnd, CtrlId, wc.hInstance, BYVAL 0)

  IF hParent THEN 'CREATE OWNERDRAWN LISTBOX
     hFileLst = CreateWindowEx(%WS_EX_CLIENTEDGE, "LISTBOX", BYVAL 0, %WS_CHILD OR _
                             %WS_VISIBLE OR %LBS_OWNERDRAWFIXED OR %LBS_HASSTRINGS OR _
                             selStyle OR %LBS_NOTIFY OR %WS_TABSTOP OR %WS_VSCROLL, _
                             0, 0, vWidth, vHeight, _
                             hParent, CtrlId, wc.hInstance, BYVAL 0)
  ELSE
     EXIT FUNCTION 'return zero on failure
  END IF

  IF hFileLst THEN
     fd = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, SIZEOF(@fd))
     IF fd THEN 'store pointer to memory for UDT in parent's cbWndExtra
        SetWindowLong hParent, 0, fd
      ELSE
        EXIT FUNCTION
     END IF

     lbFont = GetStockObject(%ANSI_VAR_FONT) 'set standard Windows font
     IF lbFont THEN SendMessage hFileLst, %WM_SETFONT, lbFont, 0

     'Subclass list and store pointer to old procedure in structure
     @fd.oldProc = SetWindowLong(hFileLst, %GWL_WNDPROC, BYVAL CODEPTR(PBFileProc))
 
     GetWindowRect hFileLst, rc 'resize container to list
     SetWindowPos hParent, 0, 0, 0, rc.nRight - rc.nLeft, _
                   rc.nBottom - rc.nTop, %SWP_NOMOVE OR %SWP_NOZORDER

     IF cDir  = "" THEN cDir = CURDIR$  'initiate
     IF fType = "" THEN fType = "*.*"
     PBFilesToList hFileLst, cDir, fType, _
                   %FILE_ATTRIBUTE_ARCHIVE OR %FILE_ATTRIBUTE_READONLY
  END IF

  FUNCTION = hFileLst 'return the listbox handle
END FUNCTION

'
' Container procedure
'
FUNCTION PBFileMainProc(BYVAL hWnd   AS DWORD, BYVAL wMsg   AS DWORD,_
                       BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
  SELECT CASE wMsg
     CASE %WM_DESTROY 'Un-subclass listbox when it's detroyed
        LOCAL fd AS PBFILECTLDATA PTR
        fd = GetWindowLong(hWnd, 0)    'Get stored data
        IF @fd.oldProc THEN SetWindowLong GetWindow(hWnd, %GW_CHILD), %GWL_WNDPROC, @fd.oldProc
        HeapFree GetProcessHeap(), 0, BYVAL fd  'free memory
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_SETFOCUS
        SetFocus GetWindow(hWnd, %GW_CHILD)  'Move focus to next control
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_CTLCOLORLISTBOX 'set appropriate background color to list
        IF IsWindowEnabled(GetWindow(hWnd, %GW_CHILD)) THEN
           FUNCTION = GetSysColorBrush(%COLOR_WINDOW)
        ELSE
           FUNCTION = GetSysColorBrush(%COLOR_3DFACE)
        END IF
        EXIT FUNCTION

     CASE %WM_DRAWITEM 'pass on to control
        SendMessage GetDlgItem(hWnd, wParam), wMsg, wParam, lParam
        FUNCTION = %TRUE : EXIT FUNCTION

     CASE %WM_COMMAND  'pass these on to container's parent
        SendMessage GetParent(hWnd), wMsg, wParam, lParam
        FUNCTION = 0 : EXIT FUNCTION

  END SELECT
  FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam) 'default message processing
END FUNCTION

'
' Subclassed control's procedure
'
FUNCTION PBFileProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                    BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

  LOCAL hDC AS DWORD, rc AS RECT, fd AS PBFILECTLDATA PTR
  fd = GetWindowLong(GetParent(hWnd), 0) 'Get stored data

  SELECT CASE wMsg
     CASE %DCM_SETFILES
        IF lParam THEN
           LOCAL zpStr AS ASCIIZ PTR
           zpStr = lParam
           IF LEN(@zpStr) THEN
              PBFilesToList hWnd, @zpStr, @fd.fileType, %FILE_ATTRIBUTE_ARCHIVE OR %FILE_ATTRIBUTE_READONLY
           END IF
        END IF

     CASE %DCM_SETFILESEL3DFACE 'select selection color scheme
        @fd.sel3Dface = wParam
        IF lParam THEN
           InvalidateRect hWnd, BYVAL %NULL, 0
           UpdateWindow hWnd
        END IF

     CASE %WM_ENABLE 'need to redraw whole list background
        GetClientRect hWnd, rc
        hDC = GetDc( hWnd)
        IF wParam THEN
           FillRect hDC, rc, GetSysColorBrush(%COLOR_WINDOW) 'clear whole background
        ELSE
           FillRect hDC, rc, GetSysColorBrush(%COLOR_3DFACE) 'clear whole background
        END IF
        ReleaseDc hWnd, hDC

     CASE %WM_GETDLGCODE   'make sure we get these keys
        LOCAL iMsg AS DWORD, pMsg AS TAGMSG PTR : pMsg = lParam
        IF pMsg THEN iMsg = @pMsg.Message
        IF iMsg = %WM_KEYDOWN THEN 'all we want to handle is the Enter key, so..
           SELECT CASE @pMsg.wParam
              CASE %VK_RETURN
                 FUNCTION = %DLGC_WANTALLKEYS : EXIT FUNCTION
           END SELECT
        END IF

     CASE %WM_KEYDOWN      'respond to keyboard input
        SELECT CASE wParam
           CASE %VK_RETURN 'Enter key - simulate double-click..
              SendMessage GetParent(hWnd), %WM_COMMAND, _
                          MAKLNG(GetDlgCtrlID(hWnd), %LBN_DBLCLK), hWnd
              FUNCTION = 0 : EXIT FUNCTION
        END SELECT

     CASE %WM_DRAWITEM      'Ownerdrawn = owner draws all items self (programmer = owner)
        LOCAL lpdis AS DRAWITEMSTRUCT PTR
        lpdis = lParam
        IF @lpdis.itemID = &HFFFFFFFF& THEN EXIT FUNCTION 'empty list, take a break..

        SELECT CASE @lpdis.itemAction
           CASE %ODA_DRAWENTIRE, %ODA_SELECT
              LOCAL y AS LONG, TextDrawFlag AS LONG
              LOCAL tm AS TEXTMETRIC, zTxt AS ASCIIZ * %MAX_PATH

              TextDrawFlag = &H2  ' DST_PREFIXTEXT

              'CLEAR BACKGROUND
              IF IsWindowEnabled(hWnd) THEN                               'ENABLED CONTROL
                 IF (@lpdis.itemState AND %ODS_SELECTED) = 0 THEN         'if not selected
                    FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_WINDOW) 'clear background
                    SetBkColor @lpdis.hDC, GetSysColor(%COLOR_WINDOW)        'text background
                    SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)  'text color
                 ELSE
                    IF @fd.sel3Dface THEN 'control is set to use custom sel color
                       FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_3DFACE) 'clear background
                       SetBkColor @lpdis.hDC, GetSysColor(%COLOR_3DFACE)     'text background
                       SetTextColor @lpdis.hDC, GetSysColor(%COLOR_BTNTEXT)  'text color
                    ELSE
                       FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_HIGHLIGHT) 'clear background
                       SetBkColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT)        'text background
                       SetTextColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT)  'text color
                    END IF
                 END IF

              ELSE                                                        'DISABLED CONTROL
                 FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_3DFACE) 'clear background
                 SetBkColor @lpdis.hDC, GetSysColor(%COLOR_3DFACE)        'text background
                 SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)  'text color
                 TextDrawFlag = TextDrawFlag OR &H20 ' DSS_DISABLED
              END IF

              'CALCULATE CENTERED Y POS
              GetTextMetrics @lpdis.hDC, tm  'get font size
              y = (@lpdis.rcItem.nBottom + @lpdis.rcItem.nTop - tm.tmHeight) / 2 'to center text

              'GET AND DRAW FILENAME PART OF TEXT - DratState looks better if control is disabled..
              SendMessage hWnd, %LB_GETTEXT, @lpdis.itemID, VARPTR(zTxt) 'Get text

              IF PBFileExist(@fd.curPath + zTxt) = 0 THEN 'if not file exists, refresh list and exit
                 PBFilesToList hWnd, @fd.curPath, @fd.fileType, _
                               %FILE_ATTRIBUTE_ARCHIVE OR %FILE_ATTRIBUTE_READONLY
                 EXIT FUNCTION
              END IF

              DrawState @lpdis.hDC, 0, 0, BYVAL VARPTR(zTxt), LEN(zTxt), _
                        2, y, @lpdis.rcItem.nRight, @lpdis.rcItem.nBottom, TextDrawFlag

           CASE %ODA_FOCUS
              DrawFocusRect @lpdis.hDC, @lpdis.rcItem 'draw focus rectangle in list

        END SELECT
        FUNCTION = %TRUE : EXIT FUNCTION

  END SELECT

  FUNCTION = CallWindowProc(@fd.oldProc, hWnd, wMsg, wParam, lParam) 'process other messages
END FUNCTION

'
' PBFileExist - make sure a file exists
'
FUNCTION PBFileExist(BYVAL sfName AS STRING) AS LONG
  LOCAL hRes AS DWORD, tWFD AS WIN32_FIND_DATA

  hRes = FindFirstFile(BYVAL STRPTR(sfName), tWFD)
  IF hRes <> %INVALID_HANDLE_VALUE THEN
     FUNCTION = %TRUE
     FindClose hRes
  END IF
END FUNCTION

'
' Populate a Listbox with available files
'
SUB PBFilesToList(BYVAL hWnd AS LONG, BYVAL AbsPath AS STRING, BYVAL fType AS STRING, BYVAL xAttr AS LONG)
  LOCAL hSearch AS DWORD, Path AS STRING, arr() AS STRING, fc AS LONG
  LOCAL WFD AS WIN32_FIND_DATA, ii AS LONG, flag AS LONG

  LOCAL fd AS PBFILECTLDATA PTR
  fd = GetWindowLong(GetParent(hWnd), 0) 'Get stored data

'  xAttr = %FILE_ATTRIBUTE_ARCHIVE OR %FILE_ATTRIBUTE_HIDDEN OR _
'          %FILE_ATTRIBUTE_READONLY OR %FILE_ATTRIBUTE_SYSTEM

  IF xAttr = 0 THEN xAttr = %FILE_ATTRIBUTE_ARCHIVE OR %FILE_ATTRIBUTE_READONLY
  IF RIGHT$(AbsPath, 1) <> "\" THEN AbsPath = AbsPath & "\"

  @fd.curPath  = AbsPath 'store current path and listed file type
  @fd.fileType = fType
  Path = AbsPath
  AbsPath = AbsPath + fType

  hSearch = FindFirstFile(BYVAL STRPTR(AbsPath), WFD) 'Loop through directory
  IF hSearch <> %INVALID_HANDLE_VALUE THEN
     DO
        IF (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY) = 0 THEN     'no dirs, files only..
           IF WFD.dwFileAttributes = 0 THEN
              flag = 1 'no attributes set - always list
           ELSE
              IF (xAttr AND %FILE_ATTRIBUTE_ARCHIVE) AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_ARCHIVE)  THEN flag = 1
              IF flag = 0 AND (xAttr AND %FILE_ATTRIBUTE_HIDDEN) AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_HIDDEN)   THEN flag = 1
              IF flag = 0 AND (xAttr AND %FILE_ATTRIBUTE_READONLY) AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_READONLY) THEN flag = 1
              IF flag = 0 AND (xAttr AND %FILE_ATTRIBUTE_SYSTEM) AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_SYSTEM)   THEN flag = 1
              IF flag = 0 AND (xAttr AND %FILE_ATTRIBUTE_NORMAL) AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_NORMAL)   THEN flag = 1

              IF flag = 1 AND (xAttr AND %FILE_ATTRIBUTE_ARCHIVE) = 0 AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_ARCHIVE)  THEN flag = 0
              IF flag = 1 AND (xAttr AND %FILE_ATTRIBUTE_HIDDEN) = 0 AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_HIDDEN)   THEN flag = 0
              IF flag = 1 AND (xAttr AND %FILE_ATTRIBUTE_READONLY) = 0 AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_READONLY) THEN flag = 0
              IF flag = 1 AND (xAttr AND %FILE_ATTRIBUTE_SYSTEM) = 0 AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_SYSTEM)   THEN flag = 0
              IF flag = 1 AND (xAttr AND %FILE_ATTRIBUTE_NORMAL) = 0 AND _
                 (WFD.dwFileAttributes AND %FILE_ATTRIBUTE_NORMAL)   THEN flag = 0
           END IF

           IF flag THEN
              flag = 0
              AbsPath = TRIM$(WFD.cFileName, CHR$(0))
              REDIM PRESERVE arr(fc)
              arr(fc) = AbsPath
              INCR fc
           END IF
        END IF
     LOOP WHILE FindNextFile(hSearch, WFD) ' Get next
     FindClose hSearch
  END IF

  ARRAY SORT arr(0), COLLATE UCASE 'sort file array

  SendMessage hWnd, %WM_SETREDRAW, 0, 0     'turn off redraw
  SendMessage hWnd, %LB_RESETCONTENT, 0, 0  'clear list and add items
  FOR ii = 0 TO UBOUND(arr)
     SendMessage hWnd, %LB_ADDSTRING, 0, BYVAL STRPTR(arr(ii))
  NEXT
  SendMessage hWnd, %WM_SETREDRAW, 1, 0 'redraw
  InvalidateRect hWnd, BYVAL %NULL, 0 : UpdateWindow hWnd
END SUB
